do not ship /etc/DIR_COLORS.xterm (ship /etc/DIR_COLORS.lightbgcolor
instead of it, try to preserve xattrs in cp -a when possible
This commit is contained in:
parent
579172fc3b
commit
92dfad507f
160
coreutils-7.1-cp-a-xattrs.patch
Normal file
160
coreutils-7.1-cp-a-xattrs.patch
Normal file
@ -0,0 +1,160 @@
|
||||
From 2c0ac0d7fc6bce3abdbad8529e44318f1370a948 Mon Sep 17 00:00:00 2001
|
||||
From: =?utf-8?q?Ond=C5=99ej=20Va=C5=A1=C3=ADk?= <ovasik@redhat.com>
|
||||
Date: Wed, 11 Mar 2009 16:08:20 +0100
|
||||
Subject: [PATCH] cp: make -a option preserve xattrs with reduced diagnostics
|
||||
|
||||
* copy.c (copy_attr_by_fd): Reduce xattr diagnostics for 'cp -a'.
|
||||
(copy_attr_by_name): Likewise.
|
||||
* cp.c (main): preserve xattrs with -a option, when possible
|
||||
* doc/coreutils.texi: document that xattrs are preserved with
|
||||
cp -a, with no added diagnostics
|
||||
* tests/misc/xattr: Add tests for 'cp --preserve=all' and 'cp -a'.
|
||||
---
|
||||
doc/coreutils.texi | 7 +++----
|
||||
src/copy.c | 22 +++++++++++++---------
|
||||
src/cp.c | 1 +
|
||||
tests/misc/xattr | 15 +++++++++++++--
|
||||
4 files changed, 30 insertions(+), 15 deletions(-)
|
||||
|
||||
diff --git a/doc/coreutils.texi b/doc/coreutils.texi
|
||||
index 2c1fae5..0bf978a 100644
|
||||
--- a/doc/coreutils.texi
|
||||
+++ b/doc/coreutils.texi
|
||||
@@ -7262,10 +7262,9 @@ Preserve as much as possible of the structure and attributes of the
|
||||
original files in the copy (but do not attempt to preserve internal
|
||||
directory structure; i.e., @samp{ls -U} may list the entries in a copied
|
||||
directory in a different order).
|
||||
-Try to preserve SELinux security context, but ignore any failure to do that
|
||||
-and print no corresponding diagnostic.
|
||||
-This option does not preserve extended attributes(xattr) at the moment.
|
||||
-Equivalent to @option{-dR --preserve=all} with a few exceptions.
|
||||
+Try to preserve SELinux security context and extended attributes (xattr),
|
||||
+but ignore any failure to do that and print no corresponding diagnostic.
|
||||
+Equivalent to @option{-dR --preserve=all} with the reduced diagnostics.
|
||||
|
||||
@item -b
|
||||
@itemx @w{@kbd{--backup}[=@var{method}]}
|
||||
diff --git a/src/copy.c b/src/copy.c
|
||||
index e37fead..7b4dc08 100644
|
||||
--- a/src/copy.c
|
||||
+++ b/src/copy.c
|
||||
@@ -153,13 +153,13 @@ copy_attr_quote (struct error_context *ctx ATTRIBUTE_UNUSED, char const *str)
|
||||
|
||||
static void
|
||||
copy_attr_free (struct error_context *ctx ATTRIBUTE_UNUSED,
|
||||
- char const *str ATTRIBUTE_UNUSED)
|
||||
+ char const *str ATTRIBUTE_UNUSED)
|
||||
{
|
||||
}
|
||||
|
||||
static bool
|
||||
copy_attr_by_fd (char const *src_path, int src_fd,
|
||||
- char const *dst_path, int dst_fd)
|
||||
+ char const *dst_path, int dst_fd, const struct cp_options *x)
|
||||
{
|
||||
struct error_context ctx =
|
||||
{
|
||||
@@ -167,11 +167,13 @@ copy_attr_by_fd (char const *src_path, int src_fd,
|
||||
.quote = copy_attr_quote,
|
||||
.quote_free = copy_attr_free
|
||||
};
|
||||
- return 0 == attr_copy_fd (src_path, src_fd, dst_path, dst_fd, 0, &ctx);
|
||||
+ return 0 == attr_copy_fd (src_path, src_fd, dst_path, dst_fd, 0,
|
||||
+ x->reduce_diagnostics ? NULL : &ctx);
|
||||
}
|
||||
|
||||
static bool
|
||||
-copy_attr_by_name (char const *src_path, char const *dst_path)
|
||||
+copy_attr_by_name (char const *src_path, char const *dst_path,
|
||||
+ const struct cp_options *x)
|
||||
{
|
||||
struct error_context ctx =
|
||||
{
|
||||
@@ -179,19 +181,21 @@ copy_attr_by_name (char const *src_path, char const *dst_path)
|
||||
.quote = copy_attr_quote,
|
||||
.quote_free = copy_attr_free
|
||||
};
|
||||
- return 0 == attr_copy_file (src_path, dst_path, 0, &ctx);
|
||||
+ return 0 == attr_copy_file (src_path, dst_path, 0,
|
||||
+ x-> reduce_diagnostics ? NULL :&ctx);
|
||||
}
|
||||
#else /* USE_XATTR */
|
||||
|
||||
static bool
|
||||
copy_attr_by_fd (char const *src_path, int src_fd,
|
||||
- char const *dst_path, int dst_fd)
|
||||
+ char const *dst_path, int dst_fd, const struct cp_options *x)
|
||||
{
|
||||
return true;
|
||||
}
|
||||
|
||||
static bool
|
||||
-copy_attr_by_name (char const *src_path, char const *dst_path)
|
||||
+copy_attr_by_name (char const *src_path, char const *dst_path,
|
||||
+ const struct cp_options *x)
|
||||
{
|
||||
return true;
|
||||
}
|
||||
@@ -759,7 +763,7 @@ copy_reg (char const *src_name, char const *dst_name,
|
||||
set_author (dst_name, dest_desc, src_sb);
|
||||
|
||||
if (x->preserve_xattr && ! copy_attr_by_fd (src_name, source_desc,
|
||||
- dst_name, dest_desc)
|
||||
+ dst_name, dest_desc, x)
|
||||
&& x->require_preserve_xattr)
|
||||
return false;
|
||||
|
||||
@@ -2076,7 +2080,7 @@ copy_internal (char const *src_name, char const *dst_name,
|
||||
|
||||
set_author (dst_name, -1, &src_sb);
|
||||
|
||||
- if (x->preserve_xattr && ! copy_attr_by_name (src_name, dst_name)
|
||||
+ if (x->preserve_xattr && ! copy_attr_by_name (src_name, dst_name, x)
|
||||
&& x->require_preserve_xattr)
|
||||
return false;
|
||||
|
||||
diff --git a/src/cp.c b/src/cp.c
|
||||
index af4bd60..8785076 100644
|
||||
--- a/src/cp.c
|
||||
+++ b/src/cp.c
|
||||
@@ -925,6 +925,7 @@ main (int argc, char **argv)
|
||||
x.require_preserve = true;
|
||||
if (selinux_enabled)
|
||||
x.preserve_security_context = true;
|
||||
+ x.preserve_xattr = true;
|
||||
x.reduce_diagnostics = true;
|
||||
x.recursive = true;
|
||||
break;
|
||||
diff --git a/tests/misc/xattr b/tests/misc/xattr
|
||||
index 4137c53..f067ff5 100755
|
||||
--- a/tests/misc/xattr
|
||||
+++ b/tests/misc/xattr
|
||||
@@ -1,6 +1,7 @@
|
||||
#!/bin/sh
|
||||
-# Ensure that cp --preserve=xattr and mv preserve extended attributes and
|
||||
-# install does not preserve extended attributes.
|
||||
+# Ensure that cp --preserve=xattr, cp --preserve=all and mv preserve extended
|
||||
+# attributes and install does not preserve extended attributes.
|
||||
+# cp -a should preserve xattr, error diagnostics should not be displayed
|
||||
|
||||
# Copyright (C) 2009 Free Software Foundation, Inc.
|
||||
|
||||
@@ -66,6 +67,16 @@ cp --preserve=xattr a b || fail=1
|
||||
getfattr -d b >out_b || skip_test_ "failed to get xattr of file"
|
||||
grep -F "$xattr_pair" out_b >/dev/null || fail=1
|
||||
|
||||
+#test if --preserve=all option works
|
||||
+cp --preserve=all a c || fail=1
|
||||
+getfattr -d c >out_c || skip_test_ "failed to get xattr of file"
|
||||
+grep -F "$xattr_pair" out_c >/dev/null || fail=1
|
||||
+
|
||||
+#test if -a option works without any diagnostics
|
||||
+cp -a a d 2>err && test -s err && fail=1
|
||||
+getfattr -d d >out_d || skip_test_ "failed to get xattr of file"
|
||||
+grep -F "$xattr_pair" out_d >/dev/null || fail=1
|
||||
+
|
||||
rm b || framework_failure
|
||||
|
||||
# install should never preserve xattr
|
||||
--
|
||||
1.5.6.1.156.ge903b
|
@ -1,4 +1,4 @@
|
||||
# Configuration file for the color ls utility
|
||||
# Configuration file for the color ls utility - modified for gray backgrounds
|
||||
# Synchronized with coreutils 7.1 dircolors
|
||||
# This file goes in the /etc directory, and must be world readable.
|
||||
# You can copy this file to .dir_colors in your $HOME directory to override
|
@ -2,7 +2,7 @@
|
||||
|
||||
#when USER_LS_COLORS defined do not override user LS_COLORS, but use them.
|
||||
if [ -z "$USER_LS_COLORS" ]; then
|
||||
|
||||
|
||||
alias ll='ls -l' 2>/dev/null
|
||||
alias l.='ls -d .*' 2>/dev/null
|
||||
|
||||
|
@ -1,7 +1,7 @@
|
||||
Summary: A set of basic GNU tools commonly used in shell scripts
|
||||
Name: coreutils
|
||||
Version: 7.1
|
||||
Release: 7{?dist}
|
||||
Release: 7%{?dist}
|
||||
License: GPLv3+
|
||||
Group: System Environment/Base
|
||||
Url: http://www.gnu.org/software/coreutils/
|
||||
|
Loading…
Reference in New Issue
Block a user